using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;


namespace Grouping
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridGroupingControl2 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl2)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(336, 376);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.51";
			// 
			// gridGroupingControl2
			// 
			this.gridGroupingControl2.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl2.Location = new System.Drawing.Point(368, 8);
			this.gridGroupingControl2.Name = "gridGroupingControl2";
			this.gridGroupingControl2.Size = new System.Drawing.Size(360, 376);
			this.gridGroupingControl2.TabIndex = 1;
			this.gridGroupingControl2.Text = "gridGroupingControl2";
			this.gridGroupingControl2.VersionInfo = "4.101.0.51";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(736, 390);
			this.Controls.Add(this.gridGroupingControl2);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region Get the DataSource
			DataTable dt1 = new DataTable("Table1");
			DataTable dt2 = new DataTable("Table2");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt1.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt1.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("row{0} col{1}", i, j);
					
				}
				dt1.Rows.Add(dr);
			}



			for(int i = 0; i < nCols; i++)
				dt2.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt2.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("R{0} C{1}", i, j);
					
				}
				dt2.Rows.Add(dr);
			}

			#endregion

			this.gridGroupingControl1.DataSource = dt1;
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.AllowDrop = true;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;

			this.gridGroupingControl1.DragDrop += new DragEventHandler(grid_DragDrop);
			this.gridGroupingControl1.DragOver += new DragEventHandler(grid_DragOver);
			this.gridGroupingControl1.TableControlMouseDown += new GridTableControlMouseEventHandler(grid_TableControlMouseDown);

			this.gridGroupingControl2.DataSource = dt2;
			this.gridGroupingControl2.ShowGroupDropArea = true;
			this.gridGroupingControl2.AllowDrop = true;
			this.gridGroupingControl2.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;

			this.gridGroupingControl2.DragDrop += new DragEventHandler(grid_DragDrop);
			this.gridGroupingControl2.DragOver += new DragEventHandler(grid_DragOver);
			this.gridGroupingControl2.TableControlMouseDown += new GridTableControlMouseEventHandler(grid_TableControlMouseDown);


		}



		private void grid_DragDrop(object sender, DragEventArgs e)
		{
			GridGroupingControl grid = sender  as GridGroupingControl;
			if(e.Data.GetDataPresent(typeof(SelectedRecordsCollection)))
			{
				SelectedRecordsCollection recs = e.Data.GetData(typeof(SelectedRecordsCollection)) as SelectedRecordsCollection;
				
				if(recs != null)
				{
					GridTableControl tableControl = grid.TableControl;
					Point pt =  tableControl.PointToClient(new Point(e.X, e.Y));
					int row, col;
					if(tableControl.PointToRowCol(pt, out row, out col))
					{
						GridTableCellStyleInfo style = tableControl.Model[row, col];
						if((style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell
							|| style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell))
						{
							int target = grid.Table.FilteredRecords.IndexOf(style.TableCellIdentity.DisplayElement.ParentRecord);
							foreach(SelectedRecord rec in recs)
							{
								DataRowView drv = rec.Record.GetData() as DataRowView;
								if(target > -1 && target < grid.Table.FilteredRecords.Count)
								{
									DataRowView targetDRV = grid.Table.FilteredRecords[target].GetData() as DataRowView;;
									targetDRV.BeginEdit();
									for(col = 0; col < drv.Row.ItemArray.GetLength(0); col++)
									{
										GridColumnDescriptor cd = grid.TableDescriptor.Columns[col];				
										if(col < targetDRV.Row.ItemArray.GetLength(0))
										{											
												if(grid.TableDescriptor.GroupedColumns.IndexOf(cd.Name)<0)
													targetDRV[col] = drv[col];
										}
									}
									targetDRV.EndEdit();
									targetDRV.Row.AcceptChanges();
									target += 1;
								}
							}
						}
						e.Effect = DragDropEffects.Copy;// tell source grid not to delete records
					}
				}
			}
		}

		private void grid_DragOver(object sender, DragEventArgs e)
		{
			if(e.Data.GetDataPresent(typeof(SelectedRecordsCollection)))
			{
				e.Effect = DragDropEffects.Copy;
			}
		}

		 
		
		private void grid_TableControlMouseDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMouseEventArgs e)
		{
			GridGroupingControl grid = sender  as GridGroupingControl;
			if(grid!= null)
			{
				GridTableControl tableControl = grid.TableControl;
				Point pt = new Point(e.Inner.X, e.Inner.Y);
				int row, col;
				if(tableControl.PointToRowCol(pt, out row, out col))
				{
				
					GridTableCellStyleInfo style = tableControl.PointToTableCellStyle(tableControl.PointToClient(Control.MousePosition));
					//tableControl.Model[row, col];
					if((style.TableCellIdentity.TableCellType == GridTableCellType.RecordRowHeaderCell
						|| style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordRowHeaderCell)
						&& style.TableCellIdentity.DisplayElement.ParentRecord != null
						&& style.TableCellIdentity.DisplayElement.ParentRecord.IsSelected())
					{
						DragDropEffects ef = tableControl.DoDragDrop(new DataObject(grid.Table.SelectedRecords), DragDropEffects.All);
						if(ef == DragDropEffects.Move)
						{
							//need to delete selection if you want to support this
						}
					}
				}
			}
			
			
		}

		 
	}
}
